var express = require("express");
var router = express.Router({ mergeParams: true });
const { param, validationResult } = require("express-validator");
const Order = require("../app/Order");

const dayjs = require("dayjs");
const OrderReceipt = require("../app/pdf/OrderReceipt");

router.use("/:order_id", param("order_id").isInt(), (req, res, next) => {
  Order.LOAD_ORDER_FROM_ID(req.params.order_id)
    .then((order) => {
      req.data.order = order;
      next("route");
    })
    .catch((reason) => {
      res.status(404).json({ errors: [{ msg: "Order could not be found" }] });
    });
});

router.get("/:order_id", (req, res) => {
  req.data.css.push("/styles/orders.css");
  req.data.order_receipt_url = `/key/${req.data.key.key}/orders/${req.params.order_id}/pdf`;
  res.render("key", req.data);
});

router.get("/:order_id/pdf", (req, res) => {
  let doc = OrderReceipt.CREATE_ORDER_RECEIPT(req.data.order, res);
  res.status(200).header({
    "Content-Type": "application/pdf",
  });
  doc.pipe(res);
});

module.exports = router;
